import { createElement, Fragment, forwardRef, useEffect, Children, isValidElement } from 'react';
import { createEvent, restore, createEffect, split, createStore, sample } from 'effector';
import { useStore } from 'effector-react';
import { match, compile } from 'path-to-regexp';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function m(){m=Object.assign||function(a){for(var c=1;c<arguments.length;c++){var g=arguments[c],h;for(h in g)Object.prototype.hasOwnProperty.call(g,h)&&(a[h]=g[h]);}return a};return m.apply(this,arguments)}var r,v=r||(r={});v.Pop="POP";v.Push="PUSH";v.Replace="REPLACE";var y="production"!==process.env.NODE_ENV?function(a){return Object.freeze(a)}:function(a){return a};function z(a,c){if(!a){"undefined"!==typeof console&&console.warn(c);try{throw Error(c);}catch(g){}}}
function A(a){a.preventDefault();a.returnValue="";}function E(){var a=[];return {get length(){return a.length},push:function(c){a.push(c);return function(){a=a.filter(function(a){return a!==c});}},call:function(c){a.forEach(function(a){return a&&a(c)});}}}
var F=function(a){function c(){var b=n.location,a=p.state||{};return [a.idx,y({pathname:b.pathname,search:b.search,hash:b.hash,state:a.usr||null,key:a.key||"default"})]}function g(b){if("string"===typeof b)var a=b;else {a=b.pathname;var c=b.search;b=b.hash;a=(void 0===a?"/":a)+(void 0===c?"":c)+(void 0===b?"":b);}return a}function h(b,a){void 0===a&&(a=null);var c=m,f=t;if("string"===typeof b){var d={};if(b){var e=b.indexOf("#");0<=e&&(d.hash=b.substr(e),b=b.substr(0,e));e=b.indexOf("?");0<=e&&(d.search=
b.substr(e),b=b.substr(0,e));b&&(d.pathname=b);}b=d;}return y(c({},f,{},b,{state:a,key:Math.random().toString(36).substr(2,8)}))}function w(b){x=b;b=c();l=b[0];t=b[1];B.call({action:x,location:t});}function C(b,a){function c(){C(b,a);}var f=r.Push,d=h(b,a);if(!k.length||(k.call({action:f,location:d,retry:c}),!1)){var e=[{usr:d.state,key:d.key,idx:l+1},g(d)];d=e[0];e=e[1];try{p.pushState(d,"",e);}catch(G){n.location.assign(e);}w(f);}}function D(a,c){function b(){D(a,c);}var f=r.Replace,d=h(a,c);k.length&&
(k.call({action:f,location:d,retry:b}),1)||(d=[{usr:d.state,key:d.key,idx:l},g(d)],p.replaceState(d[0],"",d[1]),w(f));}function q(a){p.go(a);}void 0===a&&(a={});a=a.window;var n=void 0===a?document.defaultView:a,p=n.history,u=null;n.addEventListener("popstate",function(){if(u)k.call(u),u=null;else {var a=r.Pop,f=c(),g=f[0];f=f[1];if(k.length)if(null!=g){var h=l-g;h&&(u={action:a,location:f,retry:function(){q(-1*h);}},q(h));}else "production"!==process.env.NODE_ENV?z(!1,"You are trying to block a POP navigation to a location that was not created by the history library. The block will fail silently in production, but in general you should do all navigation with the history library (instead of using window.history.pushState directly) to avoid this situation."):
void 0;else w(a);}});var x=r.Pop;a=c();var l=a[0],t=a[1],B=E(),k=E();null==l&&(l=0,p.replaceState(m({},p.state,{idx:l}),""));return {get action(){return x},get location(){return t},createHref:g,push:C,replace:D,go:q,back:function(){q(-1);},forward:function(){q(1);},listen:function(a){return B.push(a)},block:function(a){var b=k.push(a);1===k.length&&n.addEventListener("beforeunload",A);return function(){b();k.length||n.removeEventListener("beforeunload",A);}}}}();

var matchPath = function matchPath(pathname, path) {
  var m = match(path, {
    end: false
  })(pathname);

  if (!m) {
    return null;
  }

  var url = m.path,
      params = m.params;
  return {
    params: params,
    isExact: url === pathname
  };
};
var getPathname = function getPathname(path, params) {
  return compile(path)(params);
};
var getNavigateFxOptions = function getNavigateFxOptions(location, path) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var navigateFxOptions = {};

  if (options.method) {
    navigateFxOptions.method = options.method;
  }

  if (options.search) {
    navigateFxOptions.search = options.search === true ? location.search : options.search;
  }

  if (options.hash) {
    navigateFxOptions.hash = options.hash === true ? location.hash : options.hash;
  }

  if (path) {
    var _matchPath;

    var currentParams = ((_matchPath = matchPath(location.pathname, path)) === null || _matchPath === void 0 ? void 0 : _matchPath.params) || {};

    var params = _objectSpread2(_objectSpread2({}, currentParams), options.params);

    navigateFxOptions.pathname = getPathname(path, params);
  } else {
    navigateFxOptions.pathname = location.pathname;
  }

  return navigateFxOptions;
};

var changeLocation = createEvent();
var $location = restore(changeLocation, F.location);
var $pathname = $location.map(function (location) {
  return location.pathname;
});
var $search = $location.map(function (location) {
  return location.search;
});
var $hash = $location.map(function (location) {
  return location.hash;
});
F.listen(function (_ref) {
  var location = _ref.location;
  return changeLocation(location);
});
var navigateFx = createEffect(function (_ref2) {
  var method = _ref2.method,
      options = _objectWithoutProperties(_ref2, ["method"]);

  method === "replace" ? F.replace(options) : F.push(options);
});
var getHref = function getHref(location, path) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var navigateFxOptions = getNavigateFxOptions(location, path, options);
  return F.createHref(navigateFxOptions);
};

var createRoute = function createRoute(path) {
  var $match = $pathname.map(function (pathname) {
    return matchPath(pathname, path);
  });
  var open = createEvent();
  var close = createEvent();
  split({
    source: $match,
    match: function (_match) {
      function match(_x) {
        return _match.apply(this, arguments);
      }

      match.toString = function () {
        return _match.toString();
      };

      return match;
    }(function (match) {
      return match ? "open" : "close";
    }),
    cases: {
      open: open,
      close: close
    }
  });
  var $status = createStore(false).on(open, function () {
    return true;
  }).reset(close);
  var navigate = createEvent();
  sample({
    clock: navigate,
    source: $location,
    fn: function fn(location, options) {
      return getNavigateFxOptions(location, path, options);
    },
    target: navigateFx
  });

  var Route = function Route(_ref) {
    var exact = _ref.exact,
        children = _ref.children;
    var match = useStore($match);

    if (!match || exact && !match.isExact) {
      return null;
    }

    return /*#__PURE__*/createElement(Fragment, null, typeof children === "function" ? children(match) : children);
  };

  Route.path = path;
  Route.match = $match;
  Route.open = open;
  Route.close = close;
  Route.status = $status;
  Route.navigate = navigate;
  return Route;
};
var navigateToCurrentRoute = createEvent();
sample({
  clock: navigateToCurrentRoute,
  source: $location,
  fn: function fn(location, options) {
    return getNavigateFxOptions(location, null, options);
  },
  target: navigateFx
});

var isModifiedEvent = function isModifiedEvent(event) {
  return Boolean(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
};

var shouldNavigate = function shouldNavigate(event, target) {
  return (// onClick prevented default.
    !event.defaultPrevented && // Ignore everything but left clicks.
    event.button === 0 && ( // Let browser handle "target=_blank" etc.
    !target || target === "_self") && // Ignore clicks with modifier keys.
    !isModifiedEvent(event)
  );
};

var LinkInner = function LinkInner(_ref, ref) {
  var Route = _ref.to,
      params = _ref.params,
      search = _ref.search,
      hash = _ref.hash,
      method = _ref.method,
      onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ["to", "params", "search", "hash", "method", "onClick"]);

  var location = useStore($location);
  var navigateOptions = {
    params: params,
    search: search,
    hash: hash,
    method: method
  };
  var href = getHref(location, Route.path, navigateOptions);

  var handleClick = function handleClick(event) {
    try {
      if (onClick) onClick(event);
    } catch (error) {
      event.preventDefault();
      throw error;
    }

    if (shouldNavigate(event, props.target)) {
      event.preventDefault(); // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore https://github.com/kirillku/effector-easy-router/issues/1

      Route.navigate(navigateOptions);
    }
  };

  return /*#__PURE__*/createElement("a", _extends({
    ref: ref,
    href: href,
    onClick: handleClick
  }, props));
};

var Link = /*#__PURE__*/forwardRef(LinkInner);

var Redirect = function Redirect(_ref) {
  var Route = _ref.to,
      _ref$method = _ref.method,
      method = _ref$method === void 0 ? "replace" : _ref$method,
      options = _objectWithoutProperties(_ref, ["to", "method"]);

  useEffect(function () {
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore https://github.com/kirillku/effector-easy-router/issues/1
    Route.navigate(_objectSpread2({
      method: method
    }, options));
  }, []);
  return null;
};

var Switch = function Switch(_ref) {
  var children = _ref.children;
  var pathname = useStore($pathname);
  return Children.toArray(children).find(function (child) {
    var _child$type, _child$props;

    if (! /*#__PURE__*/isValidElement(child)) {
      return false;
    }

    var path = ((_child$type = child.type) === null || _child$type === void 0 ? void 0 : _child$type.path) || null;

    if (!path) {
      return true;
    }

    var match = matchPath(pathname, path);

    if (!match) {
      return false;
    }

    return ((_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.exact) ? match.isExact : true;
  }) || null;
};

export { $hash, $location, $pathname, $search, Link, Redirect, Switch, createRoute };
//# sourceMappingURL=index.js.map
