import type { Location } from "history";
import type { NavigateFxOptions, NavigateOptions } from "./types";
export declare const $location: import("effector").Store<Location<import("history").State>>;
export declare const $pathname: import("effector").Store<string>;
export declare const $search: import("effector").Store<string>;
export declare const $hash: import("effector").Store<string>;
export declare const navigateFx: import("effector").Effect<NavigateFxOptions, void, Error>;
export declare const getHref: <PathParamKeys extends string = never>(location: Location, path: string | null, options?: Partial<{
    params: Partial<import("./types").PathParams<PathParamKeys>>;
    search: string | boolean;
    hash: string | boolean;
    method: import("./types").HistoryMethod;
}>) => string;
